/*
# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Sant)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
# Previous Authors : Laurent Guigues, Jean-Pierre Roux
# CreaTools website : www.creatis.insa-lyon.fr/site/fr/creatools_accueil
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------
*/


#ifndef __creaImageIOWxCustomizeConfigPanel_h_INCLUDED__
#define __creaImageIOWxCustomizeConfigPanel_h_INCLUDED__

#ifdef USE_WXWIDGETS
#include <creaWx.h>
#include <creaImageIOWxGimmickView.h>


namespace creaImageIO
{
  /**
   * \ingroup GUI
   */
  //=====================================================================
 //=====================================================================
  class WxCustomizeConfigPanel : public wxPanel
  {
  public:
    WxCustomizeConfigPanel();    
    WxCustomizeConfigPanel(wxWindow *parent, 
                           wxDialog* dial,
                           WxGimmickView* view,
                           const std::string& cPath, 
                           const std::string& dPath,
                           const std::string& sEvent,
                           const std::string& sFreq);
    
    ~WxCustomizeConfigPanel();
    ///Saves the configuration
    void OnSaveConfig(wxCommandEvent& event);

  private :
        std::string copyP;
        std::string databaseP;
        std::string syncEv;
        std::string syncFr;
        wxTextCtrl* copyPath;
        wxTextCtrl* dbPath;
        wxTextCtrl* syncEvent;
        wxTextCtrl* syncFrequency;
        wxDialog* dialog;
        WxGimmickView* mView;

  }; // class WxCustomizeConfigPanel
  
  //=====================================================================
  
} // EO namespace creaImageIO

#endif // USE_WIDGETS
// EOF
#endif
